/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/googleapis/google-api-java-client-services/
 * Modify at your own risk.
 */

package com.google.api.services.sheets.v4.model;

/**
 * An axis of the chart. A chart may not have more than one axis per axis position.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Sheets API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class BasicChartAxis extends com.google.api.client.json.GenericJson {

  /**
   * The format of the title. Only valid if the axis is not associated with the domain. The link
   * field is not supported.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private TextFormat format;

  /**
   * The position of this axis.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String position;

  /**
   * The title of this axis. If set, this overrides any title inferred from headers of the data.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String title;

  /**
   * The axis title text position.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private TextPosition titleTextPosition;

  /**
   * The view window options for this axis.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private ChartAxisViewWindowOptions viewWindowOptions;

  /**
   * The format of the title. Only valid if the axis is not associated with the domain. The link
   * field is not supported.
   * @return value or {@code null} for none
   */
  public TextFormat getFormat() {
    return format;
  }

  /**
   * The format of the title. Only valid if the axis is not associated with the domain. The link
   * field is not supported.
   * @param format format or {@code null} for none
   */
  public BasicChartAxis setFormat(TextFormat format) {
    this.format = format;
    return this;
  }

  /**
   * The position of this axis.
   * @return value or {@code null} for none
   */
  public java.lang.String getPosition() {
    return position;
  }

  /**
   * The position of this axis.
   * @param position position or {@code null} for none
   */
  public BasicChartAxis setPosition(java.lang.String position) {
    this.position = position;
    return this;
  }

  /**
   * The title of this axis. If set, this overrides any title inferred from headers of the data.
   * @return value or {@code null} for none
   */
  public java.lang.String getTitle() {
    return title;
  }

  /**
   * The title of this axis. If set, this overrides any title inferred from headers of the data.
   * @param title title or {@code null} for none
   */
  public BasicChartAxis setTitle(java.lang.String title) {
    this.title = title;
    return this;
  }

  /**
   * The axis title text position.
   * @return value or {@code null} for none
   */
  public TextPosition getTitleTextPosition() {
    return titleTextPosition;
  }

  /**
   * The axis title text position.
   * @param titleTextPosition titleTextPosition or {@code null} for none
   */
  public BasicChartAxis setTitleTextPosition(TextPosition titleTextPosition) {
    this.titleTextPosition = titleTextPosition;
    return this;
  }

  /**
   * The view window options for this axis.
   * @return value or {@code null} for none
   */
  public ChartAxisViewWindowOptions getViewWindowOptions() {
    return viewWindowOptions;
  }

  /**
   * The view window options for this axis.
   * @param viewWindowOptions viewWindowOptions or {@code null} for none
   */
  public BasicChartAxis setViewWindowOptions(ChartAxisViewWindowOptions viewWindowOptions) {
    this.viewWindowOptions = viewWindowOptions;
    return this;
  }

  @Override
  public BasicChartAxis set(String fieldName, Object value) {
    return (BasicChartAxis) super.set(fieldName, value);
  }

  @Override
  public BasicChartAxis clone() {
    return (BasicChartAxis) super.clone();
  }

}
