/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/googleapis/google-api-java-client-services/
 * Modify at your own risk.
 */

package com.google.api.services.sheets.v4.model;

/**
 * The request for updating any aspect of a spreadsheet.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Sheets API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class BatchUpdateSpreadsheetRequest extends com.google.api.client.json.GenericJson {

  /**
   * Determines if the update response should include the spreadsheet resource.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean includeSpreadsheetInResponse;

  /**
   * A list of updates to apply to the spreadsheet. Requests will be applied in the order they are
   * specified. If any request is not valid, no requests will be applied.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Request> requests;

  /**
   * True if grid data should be returned. Meaningful only if include_spreadsheet_in_response is
   * 'true'. This parameter is ignored if a field mask was set in the request.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean responseIncludeGridData;

  /**
   * Limits the ranges included in the response spreadsheet. Meaningful only if
   * include_spreadsheet_in_response is 'true'.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> responseRanges;

  /**
   * Determines if the update response should include the spreadsheet resource.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIncludeSpreadsheetInResponse() {
    return includeSpreadsheetInResponse;
  }

  /**
   * Determines if the update response should include the spreadsheet resource.
   * @param includeSpreadsheetInResponse includeSpreadsheetInResponse or {@code null} for none
   */
  public BatchUpdateSpreadsheetRequest setIncludeSpreadsheetInResponse(java.lang.Boolean includeSpreadsheetInResponse) {
    this.includeSpreadsheetInResponse = includeSpreadsheetInResponse;
    return this;
  }

  /**
   * A list of updates to apply to the spreadsheet. Requests will be applied in the order they are
   * specified. If any request is not valid, no requests will be applied.
   * @return value or {@code null} for none
   */
  public java.util.List<Request> getRequests() {
    return requests;
  }

  /**
   * A list of updates to apply to the spreadsheet. Requests will be applied in the order they are
   * specified. If any request is not valid, no requests will be applied.
   * @param requests requests or {@code null} for none
   */
  public BatchUpdateSpreadsheetRequest setRequests(java.util.List<Request> requests) {
    this.requests = requests;
    return this;
  }

  /**
   * True if grid data should be returned. Meaningful only if include_spreadsheet_in_response is
   * 'true'. This parameter is ignored if a field mask was set in the request.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getResponseIncludeGridData() {
    return responseIncludeGridData;
  }

  /**
   * True if grid data should be returned. Meaningful only if include_spreadsheet_in_response is
   * 'true'. This parameter is ignored if a field mask was set in the request.
   * @param responseIncludeGridData responseIncludeGridData or {@code null} for none
   */
  public BatchUpdateSpreadsheetRequest setResponseIncludeGridData(java.lang.Boolean responseIncludeGridData) {
    this.responseIncludeGridData = responseIncludeGridData;
    return this;
  }

  /**
   * Limits the ranges included in the response spreadsheet. Meaningful only if
   * include_spreadsheet_in_response is 'true'.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getResponseRanges() {
    return responseRanges;
  }

  /**
   * Limits the ranges included in the response spreadsheet. Meaningful only if
   * include_spreadsheet_in_response is 'true'.
   * @param responseRanges responseRanges or {@code null} for none
   */
  public BatchUpdateSpreadsheetRequest setResponseRanges(java.util.List<java.lang.String> responseRanges) {
    this.responseRanges = responseRanges;
    return this;
  }

  @Override
  public BatchUpdateSpreadsheetRequest set(String fieldName, Object value) {
    return (BatchUpdateSpreadsheetRequest) super.set(fieldName, value);
  }

  @Override
  public BatchUpdateSpreadsheetRequest clone() {
    return (BatchUpdateSpreadsheetRequest) super.clone();
  }

}
