/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/googleapis/google-api-java-client-services/
 * Modify at your own risk.
 */

package com.google.api.services.sheets.v4.model;

/**
 * The style of a point on the chart.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Sheets API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class PointStyle extends com.google.api.client.json.GenericJson {

  /**
   * The point shape. If empty or unspecified, a default shape is used.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String shape;

  /**
   * The point size. If empty, a default size is used.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Double size;

  /**
   * The point shape. If empty or unspecified, a default shape is used.
   * @return value or {@code null} for none
   */
  public java.lang.String getShape() {
    return shape;
  }

  /**
   * The point shape. If empty or unspecified, a default shape is used.
   * @param shape shape or {@code null} for none
   */
  public PointStyle setShape(java.lang.String shape) {
    this.shape = shape;
    return this;
  }

  /**
   * The point size. If empty, a default size is used.
   * @return value or {@code null} for none
   */
  public java.lang.Double getSize() {
    return size;
  }

  /**
   * The point size. If empty, a default size is used.
   * @param size size or {@code null} for none
   */
  public PointStyle setSize(java.lang.Double size) {
    this.size = size;
    return this;
  }

  @Override
  public PointStyle set(String fieldName, Object value) {
    return (PointStyle) super.set(fieldName, value);
  }

  @Override
  public PointStyle clone() {
    return (PointStyle) super.clone();
  }

}
