/*
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/googleapis/google-api-java-client-services/
 * Modify at your own risk.
 */

package com.google.api.services.sheets.v4.model;

/**
 * The response from refreshing one or multiple data source objects.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Sheets API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class RefreshDataSourceResponse extends com.google.api.client.json.GenericJson {

  /**
   * All the refresh status for the data source object references specified in the request. If
   * is_all is specified, the field contains only those in failure status.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<RefreshDataSourceObjectExecutionStatus> statuses;

  static {
    // hack to force ProGuard to consider RefreshDataSourceObjectExecutionStatus used, since otherwise it would be stripped out
    // see https://github.com/google/google-api-java-client/issues/543
    com.google.api.client.util.Data.nullOf(RefreshDataSourceObjectExecutionStatus.class);
  }

  /**
   * All the refresh status for the data source object references specified in the request. If
   * is_all is specified, the field contains only those in failure status.
   * @return value or {@code null} for none
   */
  public java.util.List<RefreshDataSourceObjectExecutionStatus> getStatuses() {
    return statuses;
  }

  /**
   * All the refresh status for the data source object references specified in the request. If
   * is_all is specified, the field contains only those in failure status.
   * @param statuses statuses or {@code null} for none
   */
  public RefreshDataSourceResponse setStatuses(java.util.List<RefreshDataSourceObjectExecutionStatus> statuses) {
    this.statuses = statuses;
    return this;
  }

  @Override
  public RefreshDataSourceResponse set(String fieldName, Object value) {
    return (RefreshDataSourceResponse) super.set(fieldName, value);
  }

  @Override
  public RefreshDataSourceResponse clone() {
    return (RefreshDataSourceResponse) super.clone();
  }

}
